##// END OF EJS Templates
syntax
Unknown -
r298:fd3eb24edd57
parent child
Show More
@@ -1,763 +1,764
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 # Debian release
47 47 RELEASE=${RELEASE:=jessie}
48 48
49 49 #Kernel Branch
50 50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51 51
52 52 # URLs
53 53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59 59
60 60 # Build directories
61 61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 62 BUILDDIR="${BASEDIR}/build"
63 63
64 64 # Prepare date string for default image file name
65 65 DATE="$(date +%Y-%m-%d)"
66 66 if [ -z "$KERNEL_BRANCH" ] ; then
67 67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 68 else
69 69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 70 fi
71 71
72 72 # Chroot directories
73 73 R="${BUILDDIR}/chroot"
74 74 ETC_DIR="${R}/etc"
75 75 LIB_DIR="${R}/lib"
76 76 BOOT_DIR="${R}/boot/firmware"
77 77 KERNEL_DIR="${R}/usr/src/linux"
78 78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79 79
80 80 # Firmware directory: Blank if download from github
81 81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82 82
83 83 # General settings
84 84 SET_ARCH=${SET_ARCH}
85 85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 86 PASSWORD=${PASSWORD:=raspberry}
87 87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 90 EXPANDROOT=${EXPANDROOT:=true}
91 91
92 92 # Keyboard settings
93 93 XKB_MODEL=${XKB_MODEL:=""}
94 94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 95 XKB_VARIANT=${XKB_VARIANT:=""}
96 96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97 97
98 98 # Network settings (DHCP)
99 99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100 100
101 101 # Network settings (static)
102 102 NET_ADDRESS=${NET_ADDRESS:=""}
103 103 NET_GATEWAY=${NET_GATEWAY:=""}
104 104 NET_DNS_1=${NET_DNS_1:=""}
105 105 NET_DNS_2=${NET_DNS_2:=""}
106 106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 107 NET_NTP_1=${NET_NTP_1:=""}
108 108 NET_NTP_2=${NET_NTP_2:=""}
109 109
110 110 # APT settings
111 111 APT_PROXY=${APT_PROXY:=""}
112 112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113 113
114 114 # Feature settings
115 115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 116 ENABLE_I2C=${ENABLE_I2C:=false}
117 117 ENABLE_SPI=${ENABLE_SPI:=false}
118 118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 126 ENABLE_XORG=${ENABLE_XORG:=false}
127 127 ENABLE_WM=${ENABLE_WM:=""}
128 128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 129 ENABLE_USER=${ENABLE_USER:=true}
130 130 USER_NAME=${USER_NAME:="pi"}
131 131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133 133
134 134 # SSH settings
135 135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140 140
141 141 # Advanced settings
142 142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154 154
155 155 # Kernel compilation settings
156 156 BUILD_KERNEL=${BUILD_KERNEL:=false}
157 157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164 164
165 165 # Kernel compilation from source directory settings
166 166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170 170
171 171 # Reduce disk usage settings
172 172 REDUCE_APT=${REDUCE_APT:=true}
173 173 REDUCE_DOC=${REDUCE_DOC:=true}
174 174 REDUCE_MAN=${REDUCE_MAN:=true}
175 175 REDUCE_VIM=${REDUCE_VIM:=false}
176 176 REDUCE_BASH=${REDUCE_BASH:=false}
177 177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180 180
181 181 # Encrypted filesystem settings
182 182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187 187
188 188 # Chroot scripts directory
189 189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190 190
191 191 # Packages required in the chroot build environment
192 192 APT_INCLUDES=${APT_INCLUDES:=""}
193 193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194 194
195 195 # Packages required for bootstrapping
196 196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 197 MISSING_PACKAGES=""
198 198
199 199 # Packages installed for c/c++ build environment in chroot (keep empty)
200 200 COMPILER_PACKAGES=""
201 201
202 202 set +x
203 203
204 204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 205 if [ -n "$SET_ARCH" ]
206 206 echo "Setting Architecture specific settings"
207 207 ##################################
208 208 # 64 bit config
209 209 ##################################
210 210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
211 211 echo "64 bit mode selected - Setting up enviroment"
212 212 # 64 bit depended settings
213 213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219 219
220 220 # RPI 3 serie specific settings
221 221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
222 222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223 223
224 224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 226 else
227 227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
228 228 exit 1
229 229 fi
230 230
231 231 ##################################
232 232 # 32 bit config
233 233 ##################################
234 234 if [ "$SET_ARCH" = 32 ] ; then
235 235 echo "32 bit mode selected - Setting up enviroment"
236 236 #General 32bit configuration
237 237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
238 238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
239 239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
240 240
241 241 #Raspberry setting grouped by board compability
242 242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
243 243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
244 244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
245 245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
246 246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
247 247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
248 248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
249 249 elif [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
250 250 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
251 251 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
252 252 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
253 253 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
254 254 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
255 255 fi
256 fi
256 257
257 258 #Device specific configuration
258 259 case "$RPI_MODEL" in
259 260 0)
260 261 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
261 262 1)
262 263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
263 264 1P)
264 265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
265 266 2)
266 267 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
267 268 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
268 269 #Precompiled Kernel rpi2
269 270 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
270 271 ;;
271 272 3)
272 273 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
273 274 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
274 275 ;;
275 3P
276 3P)
276 277 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
277 278 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
278 279 ;;
279 280 *)
280 281 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
281 282 exit 1
282 283 ;;
283 284 esac
284 fi
285 #SET_ARCH not set
285 286 else
286 287 echo "error: Please set '32' or '64' as value for SET_ARCH"
287 288 exit 1
288 289 fi
289 290
290 291 # Check if the internal wireless interface is supported by the RPi model
291 292 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
292 293 echo "error: The selected Raspberry Pi model has no internal wireless interface"
293 294 exit 1
294 295 else
295 296 echo "Raspberry Pi model"
296 297 fi
297 298
298 299 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
299 300 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
300 301 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
301 302 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
302 303 exit 1
303 304 fi
304 305 fi
305 306
306 307 # Add libncurses5 to enable kernel menuconfig
307 308 if [ "$KERNEL_MENUCONFIG" = true ] ; then
308 309 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
309 310 fi
310 311
311 312 # Add ccache compiler cache for (faster) kernel cross (re)compilation
312 313 if [ "$KERNEL_CCACHE" = true ] ; then
313 314 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
314 315 fi
315 316
316 317 # Add cryptsetup package to enable filesystem encryption
317 318 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
318 319 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
319 320 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
320 321
321 322 if [ -z "$CRYPTFS_PASSWORD" ] ; then
322 323 echo "error: no password defined (CRYPTFS_PASSWORD)!"
323 324 exit 1
324 325 fi
325 326 ENABLE_INITRAMFS=true
326 327 fi
327 328
328 329 # Add initramfs generation tools
329 330 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
330 331 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
331 332 fi
332 333
333 334 # Add device-tree-compiler required for building the U-Boot bootloader
334 335 if [ "$ENABLE_UBOOT" = true ] ; then
335 336 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
336 337 fi
337 338
338 339 # Check if root SSH (v2) public key file exists
339 340 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
340 341 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
341 342 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
342 343 exit 1
343 344 fi
344 345 fi
345 346
346 347 # Check if $USER_NAME SSH (v2) public key file exists
347 348 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
348 349 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
349 350 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
350 351 exit 1
351 352 fi
352 353 fi
353 354
354 355 # Check if all required packages are installed on the build system
355 356 for package in $REQUIRED_PACKAGES ; do
356 357 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
357 358 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
358 359 fi
359 360 done
360 361
361 362 # If there are missing packages ask confirmation for install, or exit
362 363 if [ -n "$MISSING_PACKAGES" ] ; then
363 364 echo "the following packages needed by this script are not installed:"
364 365 echo "$MISSING_PACKAGES"
365 366
366 367 echo -n "\ndo you want to install the missing packages right now? [y/n] "
367 368 read confirm
368 369 [ "$confirm" != "y" ] && exit 1
369 370
370 371 # Make sure all missing required packages are installed
371 372 apt-get -qq -y install ${MISSING_PACKAGES}
372 373 fi
373 374
374 375 # Check if ./bootstrap.d directory exists
375 376 if [ ! -d "./bootstrap.d/" ] ; then
376 377 echo "error: './bootstrap.d' required directory not found!"
377 378 exit 1
378 379 fi
379 380
380 381 # Check if ./files directory exists
381 382 if [ ! -d "./files/" ] ; then
382 383 echo "error: './files' required directory not found!"
383 384 exit 1
384 385 fi
385 386
386 387 # Check if specified KERNELSRC_DIR directory exists
387 388 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
388 389 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
389 390 exit 1
390 391 fi
391 392
392 393 # Check if specified UBOOTSRC_DIR directory exists
393 394 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
394 395 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
395 396 exit 1
396 397 fi
397 398
398 399 # Check if specified FBTURBOSRC_DIR directory exists
399 400 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
400 401 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
401 402 exit 1
402 403 fi
403 404
404 405 # Check if specified CHROOT_SCRIPTS directory exists
405 406 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
406 407 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
407 408 exit 1
408 409 fi
409 410
410 411 # Check if specified device mapping already exists (will be used by cryptsetup)
411 412 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
412 413 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
413 414 exit 1
414 415 fi
415 416
416 417 # Don't clobber an old build
417 418 if [ -e "$BUILDDIR" ] ; then
418 419 echo "error: directory ${BUILDDIR} already exists, not proceeding"
419 420 exit 1
420 421 fi
421 422
422 423 # Setup chroot directory
423 424 mkdir -p "${R}"
424 425
425 426 # Check if build directory has enough of free disk space >512MB
426 427 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
427 428 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
428 429 exit 1
429 430 fi
430 431
431 432 set -x
432 433
433 434 # Call "cleanup" function on various signals and errors
434 435 trap cleanup 0 1 2 3 6
435 436
436 437 # Add required packages for the minbase installation
437 438 if [ "$ENABLE_MINBASE" = true ] ; then
438 439 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
439 440 fi
440 441
441 442 # Add required locales packages
442 443 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
443 444 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
444 445 fi
445 446
446 447 # Add parted package, required to get partprobe utility
447 448 if [ "$EXPANDROOT" = true ] ; then
448 449 APT_INCLUDES="${APT_INCLUDES},parted"
449 450 fi
450 451
451 452 # Add dbus package, recommended if using systemd
452 453 if [ "$ENABLE_DBUS" = true ] ; then
453 454 APT_INCLUDES="${APT_INCLUDES},dbus"
454 455 fi
455 456
456 457 # Add iptables IPv4/IPv6 package
457 458 if [ "$ENABLE_IPTABLES" = true ] ; then
458 459 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
459 460 fi
460 461
461 462 # Add openssh server package
462 463 if [ "$ENABLE_SSHD" = true ] ; then
463 464 APT_INCLUDES="${APT_INCLUDES},openssh-server"
464 465 fi
465 466
466 467 # Add alsa-utils package
467 468 if [ "$ENABLE_SOUND" = true ] ; then
468 469 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
469 470 fi
470 471
471 472 # Add rng-tools package
472 473 if [ "$ENABLE_HWRANDOM" = true ] ; then
473 474 APT_INCLUDES="${APT_INCLUDES},rng-tools"
474 475 fi
475 476
476 477 # Add fbturbo video driver
477 478 if [ "$ENABLE_FBTURBO" = true ] ; then
478 479 # Enable xorg package dependencies
479 480 ENABLE_XORG=true
480 481 fi
481 482
482 483 # Add user defined window manager package
483 484 if [ -n "$ENABLE_WM" ] ; then
484 485 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
485 486
486 487 # Enable xorg package dependencies
487 488 ENABLE_XORG=true
488 489 fi
489 490
490 491 # Add xorg package
491 492 if [ "$ENABLE_XORG" = true ] ; then
492 493 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
493 494 fi
494 495
495 496 # Replace selected packages with smaller clones
496 497 if [ "$ENABLE_REDUCE" = true ] ; then
497 498 # Add levee package instead of vim-tiny
498 499 if [ "$REDUCE_VIM" = true ] ; then
499 500 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
500 501 fi
501 502
502 503 # Add dropbear package instead of openssh-server
503 504 if [ "$REDUCE_SSHD" = true ] ; then
504 505 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
505 506 fi
506 507 fi
507 508
508 509 if [ "$RELEASE" != "jessie" ] ; then
509 510 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
510 511 fi
511 512
512 513 # Configure kernel sources if no KERNELSRC_DIR
513 514 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
514 515 KERNELSRC_CONFIG=true
515 516 fi
516 517
517 518 # Configure reduced kernel
518 519 if [ "$KERNEL_REDUCE" = true ] ; then
519 520 KERNELSRC_CONFIG=false
520 521 fi
521 522
522 523 # Execute bootstrap scripts
523 524 for SCRIPT in bootstrap.d/*.sh; do
524 525 head -n 3 "$SCRIPT"
525 526 . "$SCRIPT"
526 527 done
527 528
528 529 ## Execute custom bootstrap scripts
529 530 if [ -d "custom.d" ] ; then
530 531 for SCRIPT in custom.d/*.sh; do
531 532 . "$SCRIPT"
532 533 done
533 534 fi
534 535
535 536 # Execute custom scripts inside the chroot
536 537 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
537 538 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
538 539 chroot_exec /bin/bash -x <<'EOF'
539 540 for SCRIPT in /chroot_scripts/* ; do
540 541 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
541 542 $SCRIPT
542 543 fi
543 544 done
544 545 EOF
545 546 rm -rf "${R}/chroot_scripts"
546 547 fi
547 548
548 549 # Remove c/c++ build environment from the chroot
549 550 chroot_remove_cc
550 551
551 552 # Remove apt-utils
552 553 if [ "$RELEASE" = "jessie" ] ; then
553 554 chroot_exec apt-get purge -qq -y --force-yes apt-utils
554 555 fi
555 556
556 557 # Generate required machine-id
557 558 MACHINE_ID=$(dbus-uuidgen)
558 559 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
559 560 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
560 561
561 562 # APT Cleanup
562 563 chroot_exec apt-get -y clean
563 564 chroot_exec apt-get -y autoclean
564 565 chroot_exec apt-get -y autoremove
565 566
566 567 # Unmount mounted filesystems
567 568 umount -l "${R}/proc"
568 569 umount -l "${R}/sys"
569 570
570 571 # Clean up directories
571 572 rm -rf "${R}/run/*"
572 573 rm -rf "${R}/tmp/*"
573 574
574 575 # Clean up files
575 576 rm -f "${ETC_DIR}/ssh/ssh_host_*"
576 577 rm -f "${ETC_DIR}/dropbear/dropbear_*"
577 578 rm -f "${ETC_DIR}/apt/sources.list.save"
578 579 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
579 580 rm -f "${ETC_DIR}/*-"
580 581 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
581 582 rm -f "${ETC_DIR}/resolv.conf"
582 583 rm -f "${R}/root/.bash_history"
583 584 rm -f "${R}/var/lib/urandom/random-seed"
584 585 rm -f "${R}/initrd.img"
585 586 rm -f "${R}/vmlinuz"
586 587 rm -f "${R}${QEMU_BINARY}"
587 588
588 589 if [ "$ENABLE_QEMU" = true ] ; then
589 590 # Configure qemu compatible kernel
590 591 DTB_FILE=vexpress-v2p-ca15_a7.dtb
591 592 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
592 593 KERNEL_DEFCONFIG="vexpress_defconfig"
593 594 if [ "$KERNEL_MENUCONFIG" = false ] ; then
594 595 KERNEL_OLDDEFCONFIG=true
595 596 fi
596 597
597 598 # Setup QEMU directory
598 599 mkdir "${BASEDIR}/qemu"
599 600
600 601 # Copy kernel image to QEMU directory
601 602 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
602 603
603 604 # Copy kernel config to QEMU directory
604 605 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
605 606
606 607 # Copy kernel dtbs to QEMU directory
607 608 for dtb in "${BOOT_DIR}/"*.dtb ; do
608 609 if [ -f "${dtb}" ] ; then
609 610 install_readonly "${dtb}" "${BASEDIR}/qemu/"
610 611 fi
611 612 done
612 613
613 614 # Copy kernel overlays to QEMU directory
614 615 if [ -d "${BOOT_DIR}/overlays" ] ; then
615 616 # Setup overlays dtbs directory
616 617 mkdir "${BASEDIR}/qemu/overlays"
617 618
618 619 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
619 620 if [ -f "${dtb}" ] ; then
620 621 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
621 622 fi
622 623 done
623 624 fi
624 625
625 626 # Copy u-boot files to QEMU directory
626 627 if [ "$ENABLE_UBOOT" = true ] ; then
627 628 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
628 629 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
629 630 fi
630 631 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
631 632 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
632 633 fi
633 634 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
634 635 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
635 636 fi
636 637 fi
637 638
638 639 # Copy initramfs to QEMU directory
639 640 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
640 641 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
641 642 fi
642 643 fi
643 644
644 645 # Calculate size of the chroot directory in KB
645 646 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
646 647
647 648 # Calculate the amount of needed 512 Byte sectors
648 649 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
649 650 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
650 651 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
651 652
652 653 # The root partition is EXT4
653 654 # This means more space than the actual used space of the chroot is used.
654 655 # As overhead for journaling and reserved blocks 35% are added.
655 656 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
656 657
657 658 # Calculate required image size in 512 Byte sectors
658 659 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
659 660
660 661 # Prepare image file
661 662 if [ "$ENABLE_SPLITFS" = true ] ; then
662 663 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
663 664 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
664 665 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
665 666 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
666 667
667 668 # Write firmware/boot partition tables
668 669 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
669 670 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
670 671 EOM
671 672
672 673 # Write root partition table
673 674 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
674 675 ${TABLE_SECTORS},${ROOT_SECTORS},83
675 676 EOM
676 677
677 678 # Setup temporary loop devices
678 679 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
679 680 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
680 681 else # ENABLE_SPLITFS=false
681 682 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
682 683 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
683 684
684 685 # Write partition table
685 686 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
686 687 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
687 688 ${ROOT_OFFSET},${ROOT_SECTORS},83
688 689 EOM
689 690
690 691 # Setup temporary loop devices
691 692 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
692 693 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
693 694 fi
694 695
695 696 if [ "$ENABLE_CRYPTFS" = true ] ; then
696 697 # Create dummy ext4 fs
697 698 mkfs.ext4 "$ROOT_LOOP"
698 699
699 700 # Setup password keyfile
700 701 touch .password
701 702 chmod 600 .password
702 703 echo -n ${CRYPTFS_PASSWORD} > .password
703 704
704 705 # Initialize encrypted partition
705 706 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
706 707
707 708 # Open encrypted partition and setup mapping
708 709 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
709 710
710 711 # Secure delete password keyfile
711 712 shred -zu .password
712 713
713 714 # Update temporary loop device
714 715 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
715 716
716 717 # Wipe encrypted partition (encryption cipher is used for randomness)
717 718 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
718 719 fi
719 720
720 721 # Build filesystems
721 722 mkfs.vfat "$FRMW_LOOP"
722 723 mkfs.ext4 "$ROOT_LOOP"
723 724
724 725 # Mount the temporary loop devices
725 726 mkdir -p "$BUILDDIR/mount"
726 727 mount "$ROOT_LOOP" "$BUILDDIR/mount"
727 728
728 729 mkdir -p "$BUILDDIR/mount/boot/firmware"
729 730 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
730 731
731 732 # Copy all files from the chroot to the loop device mount point directory
732 733 rsync -a "${R}/" "$BUILDDIR/mount/"
733 734
734 735 # Unmount all temporary loop devices and mount points
735 736 cleanup
736 737
737 738 # Create block map file(s) of image(s)
738 739 if [ "$ENABLE_SPLITFS" = true ] ; then
739 740 # Create block map files for "bmaptool"
740 741 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
741 742 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
742 743
743 744 # Image was successfully created
744 745 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
745 746 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
746 747 else
747 748 # Create block map file for "bmaptool"
748 749 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
749 750
750 751 # Image was successfully created
751 752 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
752 753
753 754 # Create qemu qcow2 image
754 755 if [ "$ENABLE_QEMU" = true ] ; then
755 756 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
756 757 QEMU_SIZE=16G
757 758
758 759 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
759 760 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
760 761
761 762 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
762 763 fi
763 764 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant